registerGameMode("Capture The Flag","CTF",1,0,0);
setGameModeHelp("Capture The Flag","Add-Ons/Gamemode_CaptureTheFlag/rules_ctf.txt");
addGameModeRule("Capture The Flag","Points per Flag","int 0 10000",10);
addGameModeRule("Capture The Flag","Points Limit","int 0 10000",0);
addGameModeRule("Capture The Flag","Flag Respawn Time","int -1 300",30);
addGameModeRule("Capture The Flag","Can Recover Flags","bool",1);
addGameModeRule("Capture The Flag","Capture Without Own","bool",0);

if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
   if(!$RTB::RTBR_ServerControl_Hook)
      exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
   RTB_registerPref("Use Extended Flag Colors","TDM: Capture The Flag","SpaceMods::Server::TeamDM::CTFDatablocks","bool","Gamemode_CaptureTheFlag",0,1,1);
   RTB_registerPref("Use Backpack Flag","TDM: Capture The Flag","SpaceMods::Server::TeamDM::CTFIntelligence","bool","Gamemode_CaptureTheFlag",0,1,1);
}
else
{
   $SpaceMods::Server::TeamDM::CTFDatablocks = 0;
   $SpaceMods::Server::TeamDM::CTFIntelligence = 0;
}

function GameMode_CTF_onModeUpdateRule0(%mini,%rulevalue,%oldvalue,%modestart)
{
   if(!%modestart)
   {
      %mini.messageAll('',"\c5Flags are now worth \c3" @ %rulevalue @ "\c5 point" @ (%rulevalue == 1 ? "" : "s") @ ".");
   }
   
   return 0;
}

function GameMode_CTF_onModeUpdateRule2(%mini,%rulevalue,%oldvalue,%modestart)
{
   if(isEventPending(%mini.ctfShowSched))
      cancel(%mini.ctfShowSched);
   %mini.ctfShowSched = %mini.schedule(1,ctfRuleShow,%mini.tdmModeRule[2],%mini.tdmModeRule[3]);
   
   return 0;
}

function GameMode_CTF_onModeUpdateRule3(%mini,%rulevalue,%oldvalue,%modestart)
{
   if(isEventPending(%mini.ctfShowSched))
      cancel(%mini.ctfShowSched);
   %mini.ctfShowSched = %mini.schedule(1,ctfRuleShow,%mini.tdmModeRule[2],%mini.tdmModeRule[3]);
   
   return 0;
}

function MinigameSO::ctfRuleShow(%mini,%time,%rec)
{
   if(%time == 0)
      %mini.messageAll('',"\c5Flags will instantly respawn if dropped.");
   else if(%rec)
      %mini.messageAll('',"\c5Dropped flags can be recovered by being touched by their team.");
   else if(%time > 0)
      %mini.messageAll('',"\c5Dropped flags will respawn after \c3" @ %time @"\c5 seconds.");
   else
      %mini.messageAll('',"\c5Dropped flags cannot be recovered to base.");
}

function GameMode_CTF_onModeUpdateRule1(%mini,%rulevalue,%oldvalue,%modestart)
{
   //Reset the minigame to update limits
   return 1;
}

function GameMode_CTF_onModeStart(%mini,%client)
{
 for(%i=0;%i<%mini.numMembers;%i++)
 {
  %c = %mini.member[%i];
  if(isObject(%c.player))
  {
   if(isObject(%c.player.ctfFlagSpawnBrick))
   {
    if($SpaceMods::Server::TeamDM::CTFIntelligence)
    {
     %c.player.unMountImage(2);
    }
    else
    {
     %c.player.unMountImage(0);
     %c.player.playthread(2, root);
     fixArmReady(%c.player);
    }
   }
   %c.player.ctfFlagSpawnBrick = "";
  }
 }
 
 %mini.updateCTFBricks();
}

function GameMode_CTF_onModeEnd(%mini)
{
   for(%i=0;%i<%mini.numMembers;%i++)
   {
      %mini.removeCTFBricks(%mini.member[%i]);
   }
}

function GameMode_CTF_onMiniReset(%mini,%client)
{
 for(%i=0;%i<%mini.numMembers;%i++)
 {
  %c = %mini.member[%i];
  if(isObject(%c.player))
  {
   %c.player.ctfFlagSpawnBrick = "";
  }
 }
 
 if(%mini.tdmModeRule[1] != 0)
  %mini.messageAll('',"\c5The first team to reach \c3" @ %mini.tdmModeRule[1] @ "\c5 point" @ (%mini.tdmModeRule[1] == 1 ? "" : "s") @ " wins.");
 %mini.setPointsLimit(%mini.tdmModeRule[1]);
 
 //Scheduled because minigame resets the items and changes it to default hammer colours
 %mini.schedule(10,updateCTFBricks);
}

//v12 breaks stuff for no reason yay
if(!isObject(CTFFlagHackySet))
   new SimSet(CTFFlagHackySet);

function SimSet::doNextFlag(%this)
{
   if(isEventPending(%this.nextFlagSched))
      return;
   
   if(%this.getCount() <= 0)
      return;
   
   %flag = %this.getObject(0);
   %col = $SpaceMods::Server::TeamDM::CTFFlagData[%flag.ctfColor].colorShiftColor;
   
   ctfFlagItem.colorShiftColor = %col;
   for(%i=0;%i<clientgroup.getcount();%i++)
   {
      if(clientgroup.getobject(%i).hasSpawnedOnce)
         clientgroup.getobject(%i).transmitDatablocks(1);
   }
   %flag.setNodeColor("ALL",%col);
   
   %this.remove(%flag);
   %this.nextFlagSched = %this.schedule(200,doNextFlag);
}

function GameMode_CTF_onAddMember(%mini,%client)
{
   if(isObject(%client.player))
      %client.player.ctfFlagSpawnBrick = "";
   
   %mini.updateCTFBricks();
   
   %time = %mini.tdmModeRule[2];
   %rec = %mini.tdmModeRule[3];
   if(%time == 0)
      messageClient(%client,'',"\c5Flags will instantly respawn if dropped.");
   else if(%rec)
      messageClient(%client,'',"\c5Dropped flags can be recovered by being touched by their team.");
   else if(%time > 0)
      messageClient(%client,'',"\c5Dropped flags will respawn after \c3" @ %time @"\c5 seconds.");
   else
      messageClient(%client,'',"\c5Dropped flags cannot be recovered to base.");
}

function GameMode_CTF_onRemoveMember(%mini,%client)
{
   if(isObject(%client.player))
   {
      if(isObject(%client.player.ctfFlagSpawnBrick))
      {
         %client.player.dropCTFFlag();
      }
   }
   
   //%mini.updateCTFBricks();
   %mini.removeCTFBricks(%client);
}

function GameMode_CTF_onClientChangeTeam(%mini,%client,%lastTeam,%newTeam)
{
   if(isObject(%client.player))
   {
      if(isObject(%client.player.ctfFlagSpawnBrick))
      {
         %client.player.dropCTFFlag();
      }
      %client.player.ctfFlagSpawnBrick = "";
   }
}

function GameMode_CTF_onClientDeath(%mini,%client,%sourceObject,%sourceClient,%damageType,%damageArea)
{
   if(isObject(%client.player))
   {
      if(isObject(%client.player.ctfFlagSpawnBrick))
      {
         %client.player.dropCTFFlag();
      }
      %client.player.ctfFlagSpawnBrick = "";
   }
}

function GameMode_CTF_onClientSpawn(%mini,%client)
{
   %client.player.ctfFlagSpawnBrick = "";
}

function GameMode_CTF_onMinigameUpdateSettings(%mini,%client,%datastring)
{
   %mini.updateCTFBricks();
}

function GameMode_CTF_onMinigameUpdateModeSettings(%mini,%client,%datastring)
{
}

function MinigameSO::updateCTFBricks(%this)
{
   if(!isObject(%this) || gameModeIDToTitle(%this.gameMode) !$= "Capture The Flag")
      return; 
   
   if(%this.useAllPlayersBricks)
   {
      for(%i=0;%i<%this.numMembers;%i++)
      {
         %group = %this.member[%i].brickGroup;
         if(!isObject(%group))
            continue;
         for(%j=0;%j<%group.tdmBrickCount;%j++)
         {
            %o = %group.tdmBrick[%j];
            if(!%o.dataBlock.isCTFFlagBrick)
               continue;
            if(!%this.teamExists[%o.tdmAlliedTeam-1] && %o.tdmAlliedTeam > 0)
            {
               %o.setItem(0);
               %removed[%o.getID()] = 1;
            }
            else
            {
               %set = 1;
               for(%k=0;%k<%this.numMembers;%k++)
               {
                  %cl = %this.member[%k];
                  if(%cl.player.ctfFlagSpawnBrick == %o)
                  {
                     %set = 0;
                     break;
                  }
               }
               if(%set)
               {
                  if(%o.tdmAlliedTeam > 0)
                     %o.setCTFItem(%this.teamCol[%o.tdmAlliedTeam-1]);
                  else
                     %o.setCTFItem(getClosestPaintColor("0.5 0.5 0.5 1"));
               }
            }
         }
      }
   }
   else
   {
      for(%i=0;%i<%this.numMembers;%i++)
      {
         //If you've turned it off, then this will remove everyone else's flag spawns
         if(%this.member[%i] != %this.owner)
            %this.removeCTFBricks(%this.member[%i]);
      }
      %group = %this.owner.brickGroup;
      for(%j=0;%j<%group.tdmBrickCount;%j++)
      {
         %o = %group.tdmBrick[%j];
         if(!%o.dataBlock.isCTFFlagBrick)
            continue;
         if(!%this.teamExists[%o.tdmAlliedTeam-1] && %o.tdmAlliedTeam > 0)
         {
            %o.setItem(0);
            %removed[%o.getID()] = 1;
         }
         else
         {
            %set = 1;
            for(%k=0;%k<%this.numMembers;%k++)
            {
               %cl = %this.member[%k];
               if(%cl.player.ctfFlagSpawnBrick == %o)
               {
                  %set = 0;
                  break;
               }
            }
            if(%set)
            {
               if(%o.tdmAlliedTeam > 0)
                  %o.setCTFItem(%this.teamCol[%o.tdmAlliedTeam-1]);
               else
                  %o.setCTFItem(getClosestPaintColor("0.5 0.5 0.5 1"));
            }
         }
      }
   }
   
   for(%i=0;%i<%this.numMembers;%i++)
   {
      %cl = %this.member[%i];
      if(%removed[%cl.player.ctfFlagSpawnBrick])
      {
         if($SpaceMods::Server::TeamDM::CTFIntelligence)
         {
            %cl.player.unMountImage(2);
         }
         else
         {
            %cl.player.unMountImage(0);
            %cl.player.playthread(2, root);
            fixArmReady(%cl.player);
            if(%this.currTool != -1)
               servercmdUseTool(%cl.player,%cl.player.currTool);
         }
         %cl.player.ctfFlagSpawnBrick = "";
      }
   }
}

function MinigameSO::removeCTFBricks(%this,%client)
{
   %group = %client.brickGroup;
   for(%j=0;%j<%group.tdmBrickCount;%j++)
   {
      %o = %group.tdmBrick[%j];
      if(!%o.dataBlock.isCTFFlagBrick)
         continue;
      %o.setItem(0);
      %removed[%o.getID()] = 1;
   }
   
   for(%i=0;%i<%this.numMembers;%i++)
   {
      %cl = %this.member[%i];
      if(%removed[%cl.player.ctfFlagSpawnBrick])
      {
         if($SpaceMods::Server::TeamDM::CTFIntelligence)
         {
            %cl.player.unMountImage(2);
         }
         else
         {
            %cl.player.unMountImage(0);
            %cl.player.playthread(2, root);
            fixArmReady(%cl.player);
            if(%this.currTool != -1)
               servercmdUseTool(%cl.player,%cl.player.currTool);
         }
         %cl.player.ctfFlagSpawnBrick = "";
      }
   }
}

package CTFpackage
{
 function servercmddroptool(%client,%slot)
 {
  if(isObject(%client.minigame) && isObject(%client.player.ctfFlagSpawnBrick))
  {
   %client.player.dropCTFFlag();
   return;
  }
  Parent::servercmddroptool(%client,%slot);
 }
 
 function Player::dropCTFFlag(%this)
 {
  %mini  = %this.client.minigame;
  %brick = %this.ctfFlagSpawnBrick;
  %team  = %brick.tdmAlliedTeam-1;
  
  //If you had a flag for some reason, but it shouldn't be there, remove it anyway
  %this.ctfFlagSpawnBrick = "";
  if($SpaceMods::Server::TeamDM::CTFIntelligence)
  {
     %this.unMountImage(2);
  }
  else
  {
     %this.unMountImage(0);
     %this.playthread(2, root);
     fixArmReady(%this);
     if(%this.currTool != -1)
        servercmdUseTool(%this.client,%this.currTool);
  }

  if(!isObject(%mini) || (!%mini.teamExists[%team] && %team != -1))
   return;

  //This gets the direction you are facing, plus the distance up or down: getEyeVector by itself is affected by Free Look
  %fvec = %this.getForwardVector();
  %fX = getWord(%fvec,0);
  %fY = getWord(%fvec,1);
  
  %evec = %this.getEyeVector();
  %eX = getWord(%evec,0);
  %eY = getWord(%evec,1);
  %eZ = getWord(%evec,2);
  
  %eXY = mSqrt(%eX*%eX+%eY*%eY);
  
  %aimVec = %fX*%eXY SPC %fY*%eXY SPC %eZ;
  
  %rot = rotFromTransform(%this.getTransform());
  %rot = getWords(%rot,0,2) SPC getWord(%rot,3)*180/$pi;
  
  %item = new Item()
  {
   dataBlock = ctfFlagItem;
   position = vectorAdd(%this.getHackPosition(),vectorScale(%aimVec,2));
   rotation = %rot;
   spawnBrick = %brick;
   canPickup = 1;
   static = 0;
   createTime = getSimTime();
   player = %this;
  };MissionCleanup.add(%item);
  
  if((%brick.tdmAlliedTeam) > 0)
   %col = %mini.teamCol[%team];
  else
   %col = getclosestpaintcolor("0.5 0.5 0.5 1");
  
  %item.ctfcolor = %col;
  CTFFlagHackySet.add(%item);
  CTFFlagHackySet.doNextFlag();
  
  %item.applyImpulse(%item.position,vectorscale(%aimVec,10));
  if(%mini.tdmModeRule[2] != -1)
   %item.schedule(1000,ctfRespawnFlagTick,0);
  %brick.item = %item;
  
  if((%brick.tdmAlliedTeam) > 0)
   %mini.messageAll('',clientTeamName(%this.client) @ "\c5 dropped the " @ teamName(%mini,%brick.tdmAlliedTeam-1) @ "\c5 flag.");
  else
   %mini.messageAll('',clientTeamName(%this.client) @ "\c5 dropped the flag.");
 }
 
 function fxDTSBrick::setCTFItem(%this,%col)
 {  
  %this.setItemPosition(0); //Up
  %this.setItemDirection(2); //North
  
  ctfFlagItem.uiName = "set flag";
  %this.setItem(ctfFlagItem);
  %this.item.ctfColor = %col;
  CTFFlagHackySet.add(%this.item);
  CTFFlagHackySet.doNextFlag();
  ctfFlagItem.uiName = "";
 }
 
 function fxDTSBricK::setTeamAllied(%this,%team,%client)
 {
  %oldteam = %this.tdmAlliedTeam;
  Parent::setTeamAllied(%this,%team,%client);
  
  if(!%this.dataBlock.isCTFFlagBrick)
   return;
  
  if(%team $= %oldteam)
   return;
  
  %mini = %this.getGroup().client.minigame;
  if(!isObject(%mini) || gameModeIDToTitle(%mini.gameMode) !$= "Capture The Flag" || (%this.getGroup().client != %mini.owner && !%mini.useallplayersbricks))
   return;
  
  if(!%mini.teamExists[%this.tdmAlliedTeam-1])
  {
   %this.tdmAlliedTeam = "";
  }
  
  if(%this.tdmAlliedTeam > 0)
   %this.setCTFItem(%mini.teamCol[%this.tdmAlliedTeam-1]);
  else
   %this.setCTFItem(getClosestPaintColor("0.5 0.5 0.5 1"));
  
  for(%i=0;%i<%mini.numMembers;%i++)
  {
   %cl = %mini.member[%i];
   if(%cl.player.ctfFlagSpawnBrick == %this)
   {
    if($SpaceMods::Server::TeamDM::CTFIntelligence)
    {
     %cl.player.unMountImage(2);
    }
    else
    {
     %cl.player.unMountImage(0);
     %cl.player.playthread(2, root);
     fixArmReady(%cl.player);
     if(%cl.player.currTool != -1)
        servercmdUseTool(%cl.player,%cl.player.currTool);
    }
    %cl.player.ctfFlagSpawnBrick = "";
   }
  }
 }
 
 function fxDTSBrick::onDeath(%this)
 {
  if(%this.dataBlock.isCTFFlagBrick)
  {
   %mini = %this.getGroup().client.minigame;
   if(!isObject(%mini))
    return;
   
   for(%i=0;%i<%mini.numMembers;%i++)
   {
    %cl = %mini.member[%i];
    if(%cl.player.ctfFlagSpawnBrick == %this)
    {
     %cl.player.unMountImage(0);
     %cl.player.playthread(2, root);
     fixArmReady(%cl.player);
     %cl.player.ctfFlagSpawnBrick = "";
    }
   }
  }
  Parent::onDeath(%this);
 }
 
 function fxDTSBrick::onRemove(%this)
 {
  if(%this.dataBlock.isCTFFlagBrick)
  {
   %mini = %this.getGroup().client.minigame;
   for(%i=0;%i<%mini.numMembers;%i++)
   {
    %cl = %mini.member[%i];
    if(%cl.player.ctfFlagSpawnBrick == %this)
    {
     if($SpaceMods::Server::TeamDM::CTFIntelligence)
     {
      %cl.player.unMountImage(2);
     }
     else
     {
      %cl.player.unMountImage(0);
      %cl.player.playthread(2, root);
      fixArmReady(%cl.player);
      if(%cl.player.currTool != -1)
         servercmdUseTool(%cl.player,%cl.player.currTool);
     }
     %cl.player.ctfFlagSpawnBrick = "";
    }
   }
  }
  Parent::onRemove(%this);
 }
};activatePackage(CTFPackage);

exec("./NoFlagCommands.cs");

registerOutputEvent("fxDTSBrick","ctfFlagCap","",1);
function fxDTSBrick::ctfFlagCap(%this,%client)
{
   if(!isObject(%client) || !isObject(%client.player) || %client.player.client != %client || !isObject(%client.player.ctfFlagSpawnBrick))
      return;
   
   %player = %client.player;
   %spawn = %player.ctfFlagSpawnbrick;
   %group = %this.getGroup();
   
   if(!isObject(%group.client))
      return;
   
   %gclient = %group.client;
   
   if(!isObject(%client.minigame) || !isObject(%client.minigame))
      return;
   
   %mini = %client.minigame;
   
   if(%gclient.minigame != %mini || (%gclient != %mini.owner && !%mini.useAllPlayersBricks))
      return;
   
   if(%mini.roundWon || %mini.gamemode != gameModeTitleToID("Capture the Flag"))
      return;
   
   if(%mini.tdmModeRule[4] || !%this.dataBlock.isCTFFlagBrick || (isObject(%this.item) && %this.item.dataBlock.getID() == ctfFlagItem.getID() && %this.item.static))
   {
      if($SpaceMods::Server::TeamDM::CTFIntelligence)
      {
       %client.player.unMountImage(2);
      }
      else
      {
       %client.player.unMountImage(0);
       %client.player.playthread(2, root);
       fixArmReady(%client.player);
      }
      
      if((%spawn.tdmAlliedTeam) > 0)
         %spawn.setCTFItem(%mini.teamCol[%spawn.tdmAlliedTeam-1]);
      else
         %spawn.setCTFItem(getClosestPaintColor("0.5 0.5 0.5 1"));
      
      %player.client.incScore(%mini.tdmModeRule[0]);
      %player.client.play2d(rewardSound);
      %player.emote(winStarProjectile);
      
      if((%spawn.tdmAlliedTeam) > 0)
         %mini.messageAll('',clientTeamName(%player.client) @ "\c5 returned the " @ teamName(%mini,%spawn.tdmAlliedTeam-1) @ "\c5 flag for \c3" @ %mini.tdmModeRule[0] @ "\c5 points.");
      else
         %mini.messageAll('',clientTeamName(%player.client) @ "\c5 returned the flag for \c3" @ %mini.tdmModeRule[0] @ "\c5 points.");
      
      if(%player.client.tdmTeam+1 < 3 && %player.client.tdmTeam > -1)
      {
         %spawn.onTeamCapture(%player.client.tdmTeam,%player.client);
         %this.onTeamCapture(%player.client.tdmTeam,%player.client);
      }
      
      %player.ctfFlagSpawnBrick = "";
      if(%player.currTool != -1 && !$SpaceMods::Server::TeamDM::CTFIntelligence)
      {
         servercmdUseTool(%player.client,%player.currTool);
      }
   }
   else if(!%mini.tdmModeRule[4])
   {
      %client.centerPrint(teamName(%mini,%client.tdmTeam) SPC "\c5must have its flag in base to capture!",2);
   }
}

function CTFRegisterFlagDatablocks()
{
	datablock ParticleData(PlayerCTFFlagParticle : PlayerTeleportParticleB)
	{
		sizes[0]             = PlayerTeleportParticleB.sizes[0]/2;
		sizes[1]             = PlayerTeleportParticleB.sizes[1]/2;
		sizes[2]             = PlayerTeleportParticleB.sizes[2]/2;
		dragCoefficient      = 10.0;
		lifetimems = 8000;
		lifetimevariancems = 500;	
	};
	
	datablock DebrisData(ctfPaperDebris)
	{
		shapeFile = "./paper.dts";
		lifetime = 5.0;
		minSpinSpeed = -400.0;
		maxSpinSpeed = 200.0;
		elasticity = 0.2;
		friction = 0.4;
		numBounces = 3;
		staticOnMaxBounce = true;
		snapOnMaxBounce = false;
		fade = true;
	
		gravModifier = 2;
	};
	
	datablock ParticleEmitterData(PlayerCTFFlagEmitter : PlayerTeleportEmitterB)
	{
		particles = PlayerCTFFlagParticle;
		uiName = "CTF Flag Trail";
		useEmitterColors = true;
	};
	
	datablock ItemData(ctfFlagItem : hammerItem)
	{
		shapeFile = ($SpaceMods::Server::TeamDM::CTFIntelligence ? "./intelGround.dts" : hammerItem.shapeFile);
		uiName = "";
		colorShiftColor = "1 1 1 1";
		image = ctfFlagCol0Image;
	};
	
	for(%i=0;%i<6;%i++)
	{
		datablock fxDTSBrickData(brick : brick2x2Data)
		{
			category = "SpaceMods";
			subCategory = "Team DM: CTF";
			uiName = "Team " @ %i+1 @ " Flag Spawn";
			indestructable = 1;
			
			tdmSetAllied = %i+1;
			isCTFFlagBrick = 1;
			isTDMBrick = 1;
		};brick.setName("brickTDMTeam" @ %i+1 @ "FlagSpawnData");
	}
	
	datablock fxDTSBrickData(brickTDMTeamNeutralFlagSpawnData : brick2x2Data)
	{
		category = "SpaceMods";
		subCategory = "Team DM: CTF";
		uiName = "Neutral Flag Spawn";
		
		tdmSetAllied = 0;
		indestructable = 1;
		
		isCTFFlagBrick = 1;
		isTDMBrick = 1;
	};
	
	datablock fxDTSBrickData(brickTDMFlagPointData : brick6x6fdata)
	{
		uiName = "Neutral Flag Capture";
		category = "SpaceMods";
		subCategory = "Team DM: CTF";
		indestructable = 1;
		
		isTDMBrick = 1;
		
		autoApplyEvent_Input[0] = "onPlayerTouch";
		autoApplyEvent_Target[0] = "Self";
		autoApplyEvent_Output[0] = "ctfFlagCap";
		
		autoApplyEvent_Input[1] = "onBotTouch";
		autoApplyEvent_Target[1] = "Self";
		autoApplyEvent_Output[1] = "ctfFlagCap";
	};
	
	for(%i=0;%i<4;%i++)
	{
		datablock fxDTSBrickData(brick : brick6x6fdata)
		{
			uiName = "Team " @ %i+1 @ " Flag Capture";
			category = "SpaceMods";
			subCategory = "Team DM: CTF";
			indestructable = 1;
			
			isTDMBrick = 1;
			
			autoApplyEvent_Input[0] = "onTeam" @ %i+1 @ "PlayerTouch";
			autoApplyEvent_Target[0] = "Self";
			autoApplyEvent_Output[0] = "ctfFlagCap";
		};brick.setName("brickTDMTeam" @ %i+1 @ "FlagPointData");
	}
	
	//Enabling this can add (potentially) up to 64 new datablocks, one per unique paint colour in the set.
	//You should only use this in dedicated CTF servers with few other datablocks.
	if($SpaceMods::Server::TeamDM::CTFDatablocks)
	{
		for(%i=0;%i<64;%i++)
		{
			%col = getColorIDTable(%i);
			if(getWord(%col,3) <= 0)
				continue;
			
			%col = fixAvatarColor(%col);

			if(%set[%col] $= "")
			{
				if($SpaceMods::Server::TeamDM::CTFIntelligence)
				{
					datablock ShapeBaseImageData(flag)
					{
						shapeFile = "./intelBack.dts";
						emap = true;
						
						mountPoint = 2;
						offset = "0 -0.2 -0.2";
						eyeOffset = "0 0 -1000";
						
						className = "ctfFlagImage";
						item = ctfFlagItem.getID();
						ammo = " ";
						projectile = hammerProjectile;
						projectileType = Projectile;
						
						casing = ctfPaperDebris;
						shellExitDir        = "0 -3 1";
						shellExitOffset     = "0 0 0";
						shellExitVariance   = 15.0;	
						shellVelocity       = 7.0;
						
						//melee particles shoot from eye node for consistancy
						melee = true;
						doRetraction = false;
						//raise your arm up or not
						armReady = false;
						
						doColorShift = true;
						colorShiftColor = %col;
						
						stateName[0]			= "Activate";
						stateTransitionOnTimeout[0]	= "Activate";
						stateTimeoutValue[0]		= 1;
						stateEmitter[0]			= PlayerCTFFlagEmitter;
						stateEmitterTime[0]		= 2;
						stateEmitterNode[0]		= "muzzleNode";	
						stateScript[0]			= "doMessage";
						stateEjectShell[0] = 1;
					};
				}
				else
				{
					datablock ShapeBaseImageData(flag : hammerImage)
					{
						className = "ctfFlagImage";
						item = ctfFlagItem.getID();
						ammo = " ";
						colorShiftColor = %col;
						
						raycastWeaponRange = 5;
						raycastWeaponTargets = $TypeMasks::FxBrickObjectType |	//Targets the weapon can hit: Raycasting Bricks
										$TypeMasks::PlayerObjectType |	//AI/Players
										$TypeMasks::StaticObjectType |	//Static Shapes
										$TypeMasks::TerrainObjectType |	//Terrain
										$TypeMasks::VehicleObjectType;	//Vehicles
						raycastExplosionProjectile = hammerProjectile;
						raycastExplosionSound = hammerHitSound;
						raycastDirectDamage = 15;
						raycastDirectDamageType = $DamageType::HammerDirect;
						
						stateEmitter[0]			= PlayerCTFFlagEmitter;
						stateEmitterTime[0]		= 1;
						stateEmitterNode[0]		= "muzzleNode";	
						
						stateTimeoutValue[1]		= 1;
						stateTransitionOnTimeout[1]	= "Ready";
						stateWaitForTimeout[1]		= false;
						stateEmitter[1]			= PlayerCTFFlagEmitter;
						stateEmitterTime[1]		= 1;
						stateEmitterNode[1]		= "muzzleNode";
						
						stateEmitter[2]			= PlayerCTFFlagEmitter;
						stateEmitterTime[2]		= 1;
						stateEmitterNode[2]		= "muzzleNode";
						
						stateEmitter[3]			= PlayerCTFFlagEmitter;
						stateEmitterTime[3]		= 1;
						stateEmitterNode[3]		= "muzzleNode";
						
						stateEmitter[4]			= PlayerCTFFlagEmitter;
						stateEmitterTime[4]		= 1;
						stateEmitterNode[4]		= "muzzleNode";
						
						stateEmitter[5]			= PlayerCTFFlagEmitter;
						stateEmitterTime[5]		= 1;
						stateEmitterNode[5]		= "muzzleNode";
						
						showBricks = 0;
					};
				}
				
				%set[%col] = flag.getID();
				flag.setName("ctfFlagCol" @ %i @ "Image");
			}
			$SpaceMods::Server::TeamDM::CTFFlagData[%i] = %set[%col];
		}
	}
	else
	{
		%colours[0] = "1 0 0 1";
		%colours[1] = "0 1 0 1";
		%colours[2] = "0 0 1 1";
		%colours[3] = "1 1 0 1";
		%colours[4] = "0 1 1 1";
		%colours[5] = "1 0 1 1";
		%colours[6] = "1 1 1 1";
		%colours[7] = "0.2 0.2 0.2 1";

		for(%i=0;%i<8;%i++)
		{
			%a = getClosestPaintColor(%colours[%i]);
			%col = fixAvatarColor(getColorIDTable(%a));
			%colours[%i] = %col;
			if(%set[%col] $= "")
			{
				if($SpaceMods::Server::TeamDM::CTFIntelligence)
				{
					datablock ShapeBaseImageData(flag)
					{
						shapeFile = "./intelBack.dts";
						emap = true;
						
						mountPoint = 2;
						offset = "0 -0.2 -0.2";
						eyeOffset = "0 0 -1000";
						
						className = "ctfFlagImage";
						item = ctfFlagItem.getID();
						ammo = " ";
						projectile = hammerProjectile;
						projectileType = Projectile;
						
						casing = ctfPaperDebris;
						shellExitDir        = "0 -3 1";
						shellExitOffset     = "0 0 0";
						shellExitVariance   = 15.0;	
						shellVelocity       = 7.0;
						
						//melee particles shoot from eye node for consistancy
						melee = true;
						doRetraction = false;
						//raise your arm up or not
						armReady = false;
						
						doColorShift = true;
						colorShiftColor = %col;
						
						stateName[0]			= "Activate";
						stateTransitionOnTimeout[0]	= "Activate";
						stateTimeoutValue[0]		= 1;
						stateEmitter[0]			= PlayerCTFFlagEmitter;
						stateEmitterTime[0]		= 2;
						stateEmitterNode[0]		= "muzzleNode";	
						stateScript[0]			= "doMessage";
						stateEjectShell[0] = 1;
					};
				}
				else
				{
					datablock ShapeBaseImageData(flag : hammerImage)
					{
						className = "ctfFlagImage";
						item = ctfFlagItem.getID();
						ammo = " ";
						colorShiftColor = %col;
						
						raycastWeaponRange = 5;
						raycastWeaponTargets = $TypeMasks::FxBrickObjectType |	//Targets the weapon can hit: Raycasting Bricks
										$TypeMasks::PlayerObjectType |	//AI/Players
										$TypeMasks::StaticObjectType |	//Static Shapes
										$TypeMasks::TerrainObjectType |	//Terrain
										$TypeMasks::VehicleObjectType;	//Vehicles
						raycastExplosionProjectile = hammerProjectile;
						raycastExplosionSound = hammerHitSound;
						raycastDirectDamage = 15;
						raycastDirectDamageType = $DamageType::HammerDirect;
						
						stateEmitter[0]			= PlayerCTFFlagEmitter;
						stateEmitterTime[0]		= 1;
						stateEmitterNode[0]		= "muzzleNode";	
						
						stateTimeoutValue[1]		= 1;
						stateTransitionOnTimeout[1]	= "Ready";
						stateWaitForTimeout[1]		= false;
						stateEmitter[1]			= PlayerCTFFlagEmitter;
						stateEmitterTime[1]		= 1;
						stateEmitterNode[1]		= "muzzleNode";
						
						stateEmitter[2]			= PlayerCTFFlagEmitter;
						stateEmitterTime[2]		= 1;
						stateEmitterNode[2]		= "muzzleNode";
						
						stateEmitter[3]			= PlayerCTFFlagEmitter;
						stateEmitterTime[3]		= 1;
						stateEmitterNode[3]		= "muzzleNode";
						
						stateEmitter[4]			= PlayerCTFFlagEmitter;
						stateEmitterTime[4]		= 1;
						stateEmitterNode[4]		= "muzzleNode";
						
						stateEmitter[5]			= PlayerCTFFlagEmitter;
						stateEmitterTime[5]		= 1;
						stateEmitterNode[5]		= "muzzleNode";
						
						showBricks = 0;
					};
				}
				
				%set[%col] =	flag.getID();
				%flag[%i] =	flag.getID();
				
				flagitem.image = flag.getID();
				
				flag.setName("ctfFlagCol" @ %a @ "Image");
			}
			$SpaceMods::Server::TeamDM::CTFFlagData[%a] = %set[%col];
		}

		for(%i = 0;%i < 64;%i++)
		{
			if(isObject($SpaceMods::Server::TeamDM::CTFFlagData[%i]))
				continue;
			
			%rgba = getColorIDTable(%i);
			%prevdist = 100000;
			%colorMatch = 0;
			for(%j=0;%j<8;%j++)
			{
				%color = %colours[%j];
				if(vectorDist(%rgba,getWords(%color,0,2)) < %prevdist)
				{
					%prevdist = vectorDist(%rgba,%color);
					%colormatch = %j;
				}
			}
			$SpaceMods::Server::TeamDM::CTFFlagData[%i] = %flag[%colorMatch];
		}
	}
}

if(!isObject(ctfFlagCol0Image))
{
 CTFRegisterFlagDatablocks();
}

function ctfFlagImage::onPreFire(%this, %obj, %slot)
{
	%obj.playthread(2, armattack);
}

function ctfFlagImage::onFire(%this, %obj, %slot)
{
	WeaponImage::onFire(%this, %obj, %slot);
}

function ctfFlagImage::onHitObject(%this,%obj,%slot,%col,%pos,%normal)
{
	WeaponImage::onHitObject(%this,%obj,%slot,%col,%pos,%normal);
}

function ctfFlagImage::onRaycastDamage(%this,%obj,%slot,%col,%pos,%normal,%shotVec,%crit)
{
	WeaponImage::onRaycastDamage(%this,%obj,%slot,%col,%pos,%normal,%shotVec,%crit);
}

function ctfFlagImage::isRaycastCritical(%this,%obj,%slot,%col,%pos,%normal,%hit)
{
	return WeaponImage::isRaycastCritical(%this,%obj,%slot,%col,%pos,%normal,%hit);
}

function ctfFlagImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
}

function ctfFlagImage::doMessage(%this,%obj,%slot)
{
	if(isObject(%obj.client))
		%obj.client.bottomPrint("\c5You have the \c3Flag\c5!",2);
}

function ctfFlagItem::onPickup(%this,%obj,%player,%amt)
{
	if(%player == %obj.player && (getSimTime()-%obj.createTime < 1000))
		return;
	
	if(!isObject(%player.client))
		return;
	
	if(!isObject(%obj.spawnBrick))
		return;
	
	if(%player.client.minigame != %obj.spawnBrick.getGroup().client.minigame)
	{
		if(isObject(%player.client.minigame))
			%player.client.centerPrint("This item is in a different mini-game.",2);
		else
			%player.client.centerPrint("This item is part of a mini-game.",2);
		return;
	}
	
	%mini = %player.client.minigame;
	%team = %player.client.tdmTeam;

	if(%mini.tdmModeRule[3] && !%obj.static && %obj.spawnBrick.tdmAlliedTeam-1 == %team && ((%obj.spawnBrick.tdmAlliedTeam) > 0))
	{
		%p = new Projectile()
		{
			dataBlock = deathProjectile;
			initialPosition = %obj.getPosition();
			initialVelocity = "0 0 1";
			sourceObject = %obj;
			sourceSlot = 0;
		};%p.setScale("0.25 0.25 0.25");%p.explode();
		
		%mini.messageAll('',clientTeamName(%player.client) @ "\c5 recovered the dropped " @ teamName(%mini,%obj.spawnBrick.tdmAlliedTeam-1) @ "\c5 flag.");
		%obj.spawnBrick.setCTFItem(%mini.teamCol[%obj.spawnBrick.tdmAlliedTeam-1]);
		
		%obj.spawnBrick.onTeamCaptureReset(%player.client);
		
		return; //you can't do anything else so no need for checks
	}
	
	if(!isObject(%player.ctfFlagSpawnBrick))
	{
		if(%obj.spawnBrick.tdmAlliedTeam-1 != %player.client.tdmTeam || %player.client.tdmTeam == -1)
		{
			if((%obj.spawnBrick.tdmAlliedTeam) > 0)
				%col = %mini.teamCol[%obj.spawnbrick.tdmAlliedTeam-1];
			else
				%col = getClosestPaintColor("0.5 0.5 0.5 1");
			
			if($SpaceMods::Server::TeamDM::CTFIntelligence)
			{
				%player.mountImage($SpaceMods::Server::TeamDM::CTFFlagData[%col],2);
			}
			else
			{
				%player.unMountImage(0);
				%player.playthread(2, root);
				%player.mountImage($SpaceMods::Server::TeamDM::CTFFlagData[%col],0);
				fixArmReady(%player);
			}
			
			%player.ctfFlagSpawnBrick = %obj.spawnBrick;
			if((%obj.spawnBrick.tdmAlliedTeam) > 0)
			   %mini.messageAll('',clientTeamName(%player.client) @ "\c5 has taken the " @ teamName(%mini,%player.ctfFlagSpawnBrick.tdmAlliedTeam-1) @ "\c5 flag!");
			else

			   %mini.messageAll('',clientTeamName(%player.client) @ "\c5 has taken the flag!");
			
			if(%obj.static)
			{
				%obj.spawnBrick.setItem(0);
				return 1;
			}
			else if(isObject(%obj))
				%obj.delete();
		}
	}
}

function Item::ctfRespawnFlagTick(%obj,%num)
{
	%brick = %obj.spawnBrick;
	%mini = %obj.spawnbrick.getGroup().client.minigame;
	
	if(%num < %mini.tdmModeRule[2] && %mini.tdmModeRule[2] != -1)
	{
		%num++;
		%obj.setShapeName(%mini.tdmModeRule[2] - %num + 1);
		%obj.setShapeNameColor($SpaceMods::Server::TeamDM::CTFFlagData[%mini.teamCol[%brick.tdmAlliedTeam-1]].colorShiftColor);
		%obj.schedule(1000,ctfRespawnFlagTick,%num);
		return;
	}
	
	%p = new Projectile()
	{
		dataBlock = deathProjectile;
		initialPosition = %obj.getPosition();
		initialVelocity = "0 0 1";
		sourceObject = %obj;
		sourceSlot = 0;
	};%p.setScale("0.25 0.25 0.25");%p.explode();
	
	if(isObject(%obj.spawnBrick) && isObject(%mini))
	{
		%brick = %obj.spawnBrick;
		
		if(%obj.spawnBrick.tdmAlliedTeam > 0)
			%mini.messageAll('',"\c5The " @ teamName(%mini,%brick.tdmAlliedTeam-1) @ "\c5 flag has been respawned.");
		else
			%mini.messageAll('',"\c5The flag has been respawned.");
		
		%obj.spawnBrick.onTeamCaptureReset(%obj.spawnBrick.getGroup().client);
		
		%brick.item = "";
		if((%obj.spawnBrick.tdmAlliedTeam - 1) > 0)
			%brick.setCTFItem(%mini.teamCol[%brick.tdmAlliedTeam-1]);
		else
			%brick.setCTFItem(getClosestPaintColor("0.5 0.5 0.5 1"));
	}
	
	if(isObject(%obj))
		%obj.delete();
}